/*
 * Copyright 2015 the original author or authors.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package ratpack.func;

@FunctionalInterface
public interface BiFunction<I1, I2, O> {

  O apply(I1 i1, I2 i2) throws Exception;

  default <V> BiFunction<I1, I2, V> andThen(Function<? super O, ? extends V> transform) {
    return (i1, i2) -> transform.apply(apply(i1, i2));
  }

}
